/**
 * Created by IntelliJ IDEA.
 * User: Alexander
 * Date: Nov 12, 2002
 * Time: 9:55:23 PM
 */
package ru.ezhiki.automat.human.logic;

/**
 * Action, that can be done by figure. Actions can be only two types: delay and repositioning of joints.
 */
public class Action
{
    /**
     * Type of action. Can be any string, but currently supported are 'delay' and 'position'
     */
    private String type = "";
    /**
     * Value for this action. Each action interprets this variable, as it needs to.
     */
    private String value = "";

    /**
     * Constructor.
     */
    public Action(String type, String value)
    {
        this.type = type;
        this.value = value;
    }

    /**
     * Returns type of action.
     */
    public String getType()
    {
        return type;
    }

    /**
     * Returns value for this action.
     */
    public String getValue()
    {
        return value;
    }
}
