/*
 * Created by IntelliJ IDEA.
 * User: chizhik
 * Date: 03.11.2002
 * Time: 11:20:31
 */
package ru.ezhiki.automat.human.logic;

import ru.ezhiki.automat.human.logic.Joint;

import java.util.Vector;
import java.util.HashMap;
import java.util.Iterator;
import java.util.logging.Logger;


/**
 * Holder for joints.
 */
public class Figure extends Thread
{
    /**
     * Name of the figure. Can be any string.
     */
    private String name = "No Name";
    /**
     * Author of the figure. Only for information. Can be any string.
     */
    private String author = "Unknown";
    /**
     * Date of figure creating. Only for information. Can be any string.
     */
    private String date = "Unknown";

    /**
     * Map of joints. For string indexing of them (by joints name).
     */
    private HashMap jointsMap = new HashMap();

    /**
     * Link to centralJoint.
     */
    public Joint centralJoint = null;

    /**
     * Constant to determine left parts of figure (hand and leg).
     */
    public static int LEFT = 0;
    /**
     * Constant to determine right parts of figure (hand and leg).
     */
    public static int RIGHT = 1;
    private Logger logger = null;

    /**
     * Constructor.
     */
    public Figure(String name, String authors, String date)
    {
        this.name = name;
        this.author = authors;
        this.date = date;
    }

    /**
     * Returns figure name.
     */
    public String getFigureName()
    {
        return name;
    }

    /**
     * Returns figure author.
     */
    public String getAuthor()
    {
        return author;
    }

    /**
     * Returns figure date of creation.
     */
    public String getDate()
    {
        return date;
    }

    /**
     * Set joints vector
     */
    public void setJoints(Vector joints)
    {
        jointsMap.clear();

        for (int i = 0; i < joints.size(); i++)
        {
            Joint j = (Joint) joints.elementAt(i);
            jointsMap.put(j.getJointName(), j);
        }
    }

    /**
     * Returns number of joints
     */
    public int getJointsSize()
    {
        return jointsMap.size();
    }

    /**
     * Get joint by it's name
     */
    public Joint getJointByName(String _name)
    {
        return (Joint)jointsMap.get(_name);
    }

    public void setLogger(Logger logger)
    {
        this.logger = logger;
        for (Iterator i = jointsMap.keySet().iterator(); i.hasNext();)
        {
            Joint joint = (Joint)jointsMap.get(i.next());
            joint.setLogger(logger);
        }
    }
}
