/**
 * Created by IntelliJ IDEA.
 * User: Alexander
 * Date: Nov 13, 2002
 * Time: 8:17:54 PM
 */
package ru.ezhiki.automat.human.physics;

import ru.ezhiki.automat.human.logic.Joint;

import javax.vecmath.Vector3d;

public class PhysicsModel
{
    public static double collectChildrenMass(Joint joint, Vector3d resMCenterLoc)
    {
        Vector3d resMLoc = new Vector3d(0, 0, 0);
        double resMass = 0;

        for (int i = 0; i < joint.children.size(); i++)
        {
            Joint child = (Joint)joint.children.elementAt(i);
            resMass += child.m;

            Vector3d curLoc = (Vector3d)child.mLoc.clone();
            curLoc.scale(child.m);

            resMLoc.add(curLoc);
        }

        resMLoc.scale(1/resMass);

        resMCenterLoc = resMLoc;
        return resMass;
    }
}
