/**
 * Created by IntelliJ IDEA.
 * User: Alexander
 * Date: 04.11.2002
 * Time: 12:28:39
 */
package ru.ezhiki.automat.human.vis;

import ru.ezhiki.automat.human.logic.Figure;

import javax.media.j3d.*;
import javax.vecmath.Vector3d;

import java.awt.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseMotionListener;

import com.sun.j3d.utils.universe.SimpleUniverse;

public class AutomatCanvas
{
    private Figure figure = null;

    private SimpleUniverse universe = null;
    private BranchGroup rootBranch = null;
    private TransformGroup rootTransform = null;

    public Canvas3D canvas3d = null;

    private double scale = 0.04;
    private double rotateX = Math.PI/2;
    private double rotateY = 0;
    private double rotateZ = 0;
    private double moveX = 0;
    private double moveY = 1;
    private double moveZ = 0;

    private int mousePosX = -1;
    private int mousePosY = -1;

    public AutomatCanvas(Figure figure)
    {
        canvas3d = new Canvas3D(GraphicsEnvironment.getLocalGraphicsEnvironment().
                getDefaultScreenDevice().getBestConfiguration(new GraphicsConfigTemplate3D()));
        this.figure = figure;

        canvas3d.addMouseListener(new MouseListener()
        {
            public void mouseClicked(MouseEvent e) {}

            public void mousePressed(MouseEvent e)
            {
                mousePosX = e.getX();
                mousePosY = e.getY();
            }

            public void mouseReleased(MouseEvent e) {}

            public void mouseEntered(MouseEvent e) {}

            public void mouseExited(MouseEvent e) {}
        });

        canvas3d.addMouseMotionListener(new MouseMotionListener()
        {
            public void mouseDragged(MouseEvent e)
            {
                if (mousePosX == -1 || mousePosY == -1)
                {
                    mousePosX = e.getX();
                    mousePosY = e.getY();
                    return;
                }

                rotateZ += (mousePosX - e.getX())*0.01;

                rootTransform.setTransform(getCurrentTransform());

                mousePosX = e.getX();
                mousePosY = e.getY();
            }

            public void mouseMoved(MouseEvent e) {}
        });
    }

    public void redraw()
    {
    }

    public void updateCanvas()
    {
        universe = new SimpleUniverse(canvas3d);
        universe.getViewingPlatform().setNominalViewingTransform();

        canvas3d.stopRenderer();
        universe.addBranchGraph(createSurfaceGroup());
        canvas3d.startRenderer();
    }

    private BranchGroup createSurfaceGroup()
    {
        rootBranch = new BranchGroup();

        rootTransform = new TransformGroup(getCurrentTransform());
        rootTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);

        if (figure != null)
            rootTransform.addChild(figure.centralJoint.get3dShape());

        rootBranch.addChild(rootTransform);
        rootBranch.compile();

        return rootBranch;
    }

    private Transform3D getCurrentTransform()
    {
        Transform3D rotX = new Transform3D();
        Transform3D rotY = new Transform3D();
        Transform3D rotZ = new Transform3D();

        rotX.rotX(rotateX);
        rotY.rotY(rotateY);
        rotZ.rotZ(rotateZ);

        Transform3D toView = new Transform3D();
        toView.mul(rotX);
        toView.mul(rotZ);
//        toView.mul(rotY);

        toView.setScale(scale);
        toView.setTranslation(new Vector3d(moveX, moveY, moveZ));
        return toView;
    }
}
