/**
 * Created by IntelliJ IDEA.
 * User: Alexander
 * Date: 04.11.2002
 * Time: 12:28:28
 */
package ru.ezhiki.automat.human.vis;

import ru.ezhiki.automat.human.logic.Figure;
import ru.ezhiki.automat.human.logic.Actions;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.logging.Logger;

public class AutomatFrame extends JFrame
{
    private AutomatCanvas canvas = null;
    private Figure figure = null;
    private Actions actions = null;
    private Logger logger = null;

    private JButton buttonStart = new JButton(" Start ");

    public AutomatFrame(Figure figure, Actions actions, Logger logger) throws HeadlessException
    {
        setTitle("Joint Automat");

        this.logger = logger;
        this.figure = figure;
        this.actions = actions;
        if (actions != null)
            actions.setFigure(figure);

        figure.setLogger(logger);
        actions.setLogger(logger);

        init3d();
        initLayout();
        initActions();

        canvas.updateCanvas();

        pack();
        setSize(300, 500);

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        if (frameSize.height > screenSize.height)
        {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width)
        {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width)/2, (screenSize.height - frameSize.height)/2);
    }

    private void initLayout()
    {
        getContentPane().setBackground(Color.black);
        getContentPane().add(buttonStart, BorderLayout.SOUTH);
        getContentPane().add(canvas.canvas3d, BorderLayout.CENTER);
    }

    private void initActions()
    {
        canvas.canvas3d.addKeyListener(new KeyListener()
        {
            public void keyTyped(KeyEvent e)
            {
                if (e.getKeyChar() == '1')
                {
                    actions.processActions();
                }
            }

            public void keyPressed(KeyEvent e)
            {
            }

            public void keyReleased(KeyEvent e)
            {
            }
        });

        buttonStart.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                actions.processActions();
            }
        });
    }

    private void init3d()
    {
        canvas = new AutomatCanvas(figure);
        canvas.canvas3d.setBackground(Color.black);
    }

    protected void processWindowEvent(WindowEvent e)
    {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            exitWindow();
        }
    }

    private void exitWindow()
    {
        System.exit(0);
    }
}
